Index: .doxygen.conf
===================================================================
--- .doxygen.conf	(revision 3732)
+++ .doxygen.conf	(revision 3793)
@@ -6,5 +6,5 @@
 DOXYFILE_ENCODING      = UTF-8
 PROJECT_NAME           = Dotclear
-PROJECT_NUMBER         = 2.14
+PROJECT_NUMBER         = 2.15
 PROJECT_BRIEF          =
 PROJECT_LOGO           =
Index: admin/blog_theme.php
===================================================================
--- admin/blog_theme.php	(revision 3731)
+++ admin/blog_theme.php	(revision 3812)
@@ -20,5 +20,6 @@
     $core->themes,
     $core->blog->themes_path,
-    $core->blog->settings->system->store_theme_url
+    $core->blog->settings->system->store_theme_url,
+    !empty($_GET['nocache'])
 );
 adminThemesList::$distributed_modules = explode(',', DC_DISTRIB_THEMES);
@@ -105,4 +106,10 @@
 # -- Display modules lists --
 if ($core->auth->isSuperAdmin()) {
+
+    if (!$core->error->flag()) {
+        if (!empty($_GET['nocache'])) {
+            dcPage::success(__('Manual checking of themes update done successfully.'));
+        }
+    }
 
     # Updated modules from repo
@@ -134,4 +141,10 @@
 
             '</div>';
+    } else {
+        echo
+        '<form action="' . $list->getURL('', false) . '" method="get">' .
+        '<p><input type="hidden" name="nocache" value="1" />' .
+        '<input type="submit" value="' . __('Force checking update of themes') . '" /></p>' .
+            '</form>';
     }
 }
Index: admin/js/_index.js
===================================================================
--- admin/js/_index.js	(revision 3781)
+++ admin/js/_index.js	(revision 3820)
@@ -155,4 +155,6 @@
         var xml = $('rsp>update', data).attr('ret');
         $('#content h2').after(xml);
+        // manage outgoing links
+        dotclear.outgoingLinks('#ajax-update a');
       }
     }
@@ -180,4 +182,6 @@
         }
         $('#dashboard-boxes div.db-items').prepend(xml);
+        // manage outgoing links
+        dotclear.outgoingLinks('#ajax-news a');
       }
     }
Index: admin/js/common.js
===================================================================
--- admin/js/common.js	(revision 3805)
+++ admin/js/common.js	(revision 3820)
@@ -164,30 +164,27 @@
 (function($) {
   $.expandContent = function(opts) {
-    var defaults = {};
-    $.expandContent.options = $.extend({}, defaults, opts);
     if (opts == undefined || opts.callback == undefined || !$.isFunction(opts.callback)) {
       return;
     }
     if (opts.line != undefined) {
-      multipleExpander(opts.line, opts.lines);
+      multipleExpander(opts.line, opts.lines, opts.callback);
     }
     opts.lines.each(function() {
-      singleExpander(this);
-    });
-  };
-  var singleExpander = function singleExpander(line) {
+      singleExpander(this, opts.callback);
+    });
+  };
+  var singleExpander = function singleExpander(line, callback) {
     $('<input class="details-cmd" type="submit" value="' + dotclear.img_plus_txt + '" aria-label="' + dotclear.img_plus_alt + '"/>').click(function(e) {
       toggleArrow(this);
-      $.expandContent.options.callback.call(this, line);
+      callback(line);
       e.preventDefault();
     }).prependTo($(line).children().get(0)); // first td
   };
-  var multipleExpander = function multipleExpander(line, lines) {
+  var multipleExpander = function multipleExpander(line, lines, callback) {
     $('<input class="details-cmd" type="submit" value="' + dotclear.img_plus_txt + '" aria-label="' + dotclear.img_plus_alt + '"/>').click(function(e) {
-      var that = this;
       var action = toggleArrow(this);
       lines.each(function() {
         toggleArrow(this.firstChild.firstChild, action);
-        $.expandContent.options.callback.call(that, this, action);
+        callback(this, action);
       });
       e.preventDefault();
@@ -436,4 +433,17 @@
       return true;
     });
+  },
+  outgoingLinks: function(target) {
+    $(target).filter(function() {
+      return ((this.hostname && this.hostname != location.hostname && !$(this).hasClass('modal') && !$(this).hasClass('modal-image')) || $(this).hasClass('outgoing'));
+    }).each(function() {
+      $(this).prop('title', $(this).prop('title') + ' (' + dotclear.msg.new_window + ')');
+      if (!$(this).hasClass('outgoing')) {
+        $(this).append('&nbsp;<img class="outgoing-js" src="images/outgoing-link.svg" alt=""/>');
+      }
+    }).click(function(e) {
+      e.preventDefault();
+      window.open($(this).attr('href'));
+    });
   }
 };
@@ -451,15 +461,5 @@
   });
   // manage outgoing links
-  $('a').filter(function() {
-    return ((this.hostname && this.hostname != location.hostname && !$(this).hasClass('modal') && !$(this).hasClass('modal-image')) || $(this).hasClass('outgoing'));
-  }).each(function() {
-    $(this).prop('title', $(this).prop('title') + ' (' + dotclear.msg.new_window + ')');
-    if (!$(this).hasClass('outgoing')) {
-      $(this).append('&nbsp;<img class="outgoing-js" src="images/outgoing-link.svg" alt=""/>');
-    }
-  }).click(function(e) {
-    e.preventDefault();
-    window.open($(this).attr('href'));
-  });
+  dotclear.outgoingLinks('a');
   // Popups: dealing with Escape key fired
   $('#dotclear-admin.popup').keyup(function(e) {
Index: admin/plugins.php
===================================================================
--- admin/plugins.php	(revision 3731)
+++ admin/plugins.php	(revision 3812)
@@ -16,5 +16,6 @@
     $core->plugins,
     DC_PLUGINS_ROOT,
-    $core->blog->settings->system->store_plugin_url
+    $core->blog->settings->system->store_plugin_url,
+    !empty($_GET['nocache'])
 );
 
@@ -115,4 +116,10 @@
 # -- Display modules lists --
 if ($core->auth->isSuperAdmin()) {
+
+    if (!$core->error->flag()) {
+        if (!empty($_GET['nocache'])) {
+            dcPage::success(__('Manual checking of plugins update done successfully.'));
+        }
+    }
 
     # Updated modules from repo
@@ -144,4 +151,10 @@
 
             '</div>';
+    } else {
+        echo
+        '<form action="' . $list->getURL('', false) . '" method="get">' .
+        '<p><input type="hidden" name="nocache" value="1" />' .
+        '<input type="submit" value="' . __('Force checking update of plugins') . '" /></p>' .
+            '</form>';
     }
 }
Index: admin/services.php
===================================================================
--- admin/services.php	(revision 3781)
+++ admin/services.php	(revision 3819)
@@ -86,5 +86,5 @@
                 $feed = $feed_reader->parse($GLOBALS['__resources']['rss_news']);
                 if ($feed) {
-                    $ret = '<div class="box medium dc-box"><h3>' . __('Dotclear news') . '</h3><dl id="news">';
+                    $ret = '<div class="box medium dc-box" id="ajax-news"><h3>' . __('Dotclear news') . '</h3><dl id="news">';
                     $i   = 1;
                     foreach ($feed->items as $item) {
@@ -132,5 +132,5 @@
                 if (version_compare(phpversion(), $updater->getPHPVersion()) >= 0) {
                     $ret =
-                    '<div class="dc-update"><h3>' . sprintf(__('Dotclear %s is available!'), $new_v) . '</h3> ' .
+                    '<div class="dc-update" id="ajax-update"><h3>' . sprintf(__('Dotclear %s is available!'), $new_v) . '</h3> ' .
                     '<p><a class="button submit" href="' . $core->adminurl->get("admin.update") . '">' . sprintf(__('Upgrade now'), $new_v) . '</a> ' .
                     '<a class="button" href="' . $core->adminurl->get("admin.update", array('hide_msg' => 1)) . '">' . __('Remind me later') . '</a>' .
Index: inc/admin/lib.dc.page.php
===================================================================
--- inc/admin/lib.dc.page.php	(revision 3791)
+++ inc/admin/lib.dc.page.php	(revision 3828)
@@ -169,6 +169,8 @@
         if ($core->auth->user_prefs->interface->darkmode) {
             echo self::cssLoad('style/default-dark.css');
+            echo self::jsVars(array('dotclear_darkMode' => 1));
         } else {
             echo self::cssLoad('style/default.css');
+            echo self::jsVars(array('dotclear_darkMode' => 0));
         }
         if (l10n::getTextDirection($GLOBALS['_lang']) == 'rtl') {
@@ -220,8 +222,7 @@
         '<li><a href="#content">' . __('Go to the content') . '</a></li>' .
         '<li><a href="#main-menu">' . __('Go to the menu') . '</a></li>' .
-        '<li><a href="#qx">' . __('Go to search') . '</a></li>' .
         '<li><a href="#help">' . __('Go to help') . '</a></li>' .
         '</ul>' . "\n" .
-        '<div id="header" role="banner">' .
+        '<header id="header" role="banner">' .
         '<h1><a href="' . $core->adminurl->get("admin.home") . '"><span class="hidden">' . DC_VENDOR_NAME . '</span></a></h1>' . "\n";
 
@@ -239,5 +240,5 @@
             '</span><img src="images/logout.png" alt="" /></a></li>' .
             '</ul>' .
-            '</div>'; // end header
+            '</header>'; // end header
 
         echo
@@ -247,5 +248,5 @@
         '<img class="expand-mm visually-hidden" src="images/collapser-show.png" alt="' . __('Show main menu') . '" />' .
             '</button></div>' .
-            '<div id="main" role="main">' . "\n" .
+            '<main id="main" role="main">' . "\n" .
             '<div id="content" class="clearfix">' . "\n";
 
@@ -367,7 +368,7 @@
         echo
         "</div>\n" . // End of #content
-        "</div>\n" . // End of #main
-
-        '<div id="main-menu" role="navigation">' . "\n" .
+        "</main>\n" . // End of #main
+
+        '<nav id="main-menu" role="navigation">' . "\n" .
 
         '<form id="search-menu" action="' . $core->adminurl->get("admin.search") . '" method="get" role="search">' .
@@ -390,5 +391,5 @@
 
         echo
-        '</div>' . "\n" . // End of #main-menu
+        '</nav>' . "\n" . // End of #main-menu
         "</div>\n";       // End of #wrapper
 
@@ -409,7 +410,7 @@
 
         echo
-            '<div id="footer" role="contentinfo">' .
+            '<footer id="footer" role="contentinfo">' .
             '<a href="http://dotclear.org/" title="' . $text . '">' .
-            '<img src="style/dc_logos/w-dotclear90.png" alt="' . $text . '" /></a></div>' . "\n" .
+            '<img src="style/dc_logos/w-dotclear90.png" alt="' . $text . '" /></a></footer>' . "\n" .
             "<!-- " . "\n" .
             $figure .
@@ -449,6 +450,8 @@
         if ($core->auth->user_prefs->interface->darkmode) {
             echo self::cssLoad('style/default-dark.css');
+            echo self::jsVars(array('dotclear_darkMode' => 1));
         } else {
             echo self::cssLoad('style/default.css');
+            echo self::jsVars(array('dotclear_darkMode' => 0));
         }
         if (l10n::getTextDirection($GLOBALS['_lang']) == 'rtl') {
@@ -494,5 +497,5 @@
         echo
             '<div id="wrapper">' . "\n" .
-            '<div id="main" role="main">' . "\n" .
+            '<main id="main" role="main">' . "\n" .
             '<div id="content">' . "\n";
 
@@ -508,10 +511,10 @@
         echo
         "</div>\n" . // End of #content
-        "</div>\n" . // End of #main
+        "</main>\n" . // End of #main
         "</div>\n" . // End of #wrapper
 
         '<p id="gototop"><a href="#wrapper">' . __('Page top') . '</a></p>' . "\n" .
 
-            '<div id="footer" role="contentinfo"><p>&nbsp;</p></div>' . "\n" .
+            '<footer id="footer" role="contentinfo"><p>&nbsp;</p></footer>' . "\n" .
             '</body></html>';
     }
Index: inc/admin/lib.moduleslist.php
===================================================================
--- inc/admin/lib.moduleslist.php	(revision 3775)
+++ inc/admin/lib.moduleslist.php	(revision 3812)
@@ -54,12 +54,13 @@
      *
      * @param    object    $modules        dcModules instance
-     * @param    string    $modules_root    Modules root directories
+     * @param    string    $modules_root   Modules root directories
      * @param    string    $xml_url        URL of modules feed from repository
-     */
-    public function __construct(dcModules $modules, $modules_root, $xml_url)
+     * @param    boolean   $force          Force query repository
+     */
+    public function __construct(dcModules $modules, $modules_root, $xml_url, $force = false)
     {
         $this->core    = $modules->core;
         $this->modules = $modules;
-        $this->store   = new dcStore($modules, $xml_url);
+        $this->store   = new dcStore($modules, $xml_url, $force);
 
         $this->page_url = $this->core->adminurl->get('admin.plugins');
@@ -1468,10 +1469,11 @@
      *
      * @param    object    $modules        dcModules instance
-     * @param    string    $modules_root    Modules root directories
+     * @param    string    $modules_root   Modules root directories
      * @param    string    $xml_url        URL of modules feed from repository
-     */
-    public function __construct(dcModules $modules, $modules_root, $xml_url)
-    {
-        parent::__construct($modules, $modules_root, $xml_url);
+     * @param    boolean   $force          Force query repository
+     */
+    public function __construct(dcModules $modules, $modules_root, $xml_url, $force = false)
+    {
+        parent::__construct($modules, $modules_root, $xml_url, $force);
         $this->page_url = $this->core->adminurl->get('admin.blog.theme');
     }
Index: inc/core/class.dc.store.php
===================================================================
--- inc/core/class.dc.store.php	(revision 3731)
+++ inc/core/class.dc.store.php	(revision 3812)
@@ -38,6 +38,7 @@
      * @param    object    $modules        dcModules instance
      * @param    string    $xml_url        XML feed URL
-     */
-    public function __construct(dcModules $modules, $xml_url)
+     * @param    boolean   $force          Force query repository
+     */
+    public function __construct(dcModules $modules, $xml_url, $force = false)
     {
         $this->core       = $modules->core;
@@ -46,5 +47,5 @@
         $this->user_agent = sprintf('Dotclear/%s)', DC_VERSION);
 
-        $this->check();
+        $this->check($force);
     }
 
Index: inc/dbschema/upgrade.php
===================================================================
--- inc/dbschema/upgrade.php	(revision 3731)
+++ inc/dbschema/upgrade.php	(revision 3829)
@@ -688,4 +688,14 @@
         }
 
+        if (version_compare($version, '2.15', '<')) {
+            # switch from jQuery 1.11.3 to 1.12.4
+            $strReq = 'UPDATE ' . $core->prefix . 'setting ' .
+                " SET setting_value = '1.12.4' " .
+                " WHERE setting_id = 'jquery_version' " .
+                " AND setting_ns = 'system' " .
+                " AND setting_value = '1.11.3' ";
+            $core->con->execute($strReq);
+        }
+
         $core->setVersion('core', DC_VERSION);
         $core->blogDefaults();
Index: inc/js/jquery/1.12.4/jquery.cookie.js
===================================================================
--- inc/js/jquery/1.12.4/jquery.cookie.js	(revision 3829)
+++ inc/js/jquery/1.12.4/jquery.cookie.js	(revision 3829)
@@ -0,0 +1,117 @@
+/*!
+ * jQuery Cookie Plugin v1.4.1
+ * https://github.com/carhartl/jquery-cookie
+ *
+ * Copyright 2006, 2014 Klaus Hartl
+ * Released under the MIT license
+ */
+(function (factory) {
+	if (typeof define === 'function' && define.amd) {
+		// AMD
+		define(['jquery'], factory);
+	} else if (typeof exports === 'object') {
+		// CommonJS
+		factory(require('jquery'));
+	} else {
+		// Browser globals
+		factory(jQuery);
+	}
+}(function ($) {
+
+	var pluses = /\+/g;
+
+	function encode(s) {
+		return config.raw ? s : encodeURIComponent(s);
+	}
+
+	function decode(s) {
+		return config.raw ? s : decodeURIComponent(s);
+	}
+
+	function stringifyCookieValue(value) {
+		return encode(config.json ? JSON.stringify(value) : String(value));
+	}
+
+	function parseCookieValue(s) {
+		if (s.indexOf('"') === 0) {
+			// This is a quoted cookie as according to RFC2068, unescape...
+			s = s.slice(1, -1).replace(/\\"/g, '"').replace(/\\\\/g, '\\');
+		}
+
+		try {
+			// Replace server-side written pluses with spaces.
+			// If we can't decode the cookie, ignore it, it's unusable.
+			// If we can't parse the cookie, ignore it, it's unusable.
+			s = decodeURIComponent(s.replace(pluses, ' '));
+			return config.json ? JSON.parse(s) : s;
+		} catch(e) {}
+	}
+
+	function read(s, converter) {
+		var value = config.raw ? s : parseCookieValue(s);
+		return $.isFunction(converter) ? converter(value) : value;
+	}
+
+	var config = $.cookie = function (key, value, options) {
+
+		// Write
+
+		if (arguments.length > 1 && !$.isFunction(value)) {
+			options = $.extend({}, config.defaults, options);
+
+			if (typeof options.expires === 'number') {
+				var days = options.expires, t = options.expires = new Date();
+				t.setTime(+t + days * 864e+5);
+			}
+
+			return (document.cookie = [
+				encode(key), '=', stringifyCookieValue(value),
+				options.expires ? '; expires=' + options.expires.toUTCString() : '', // use expires attribute, max-age is not supported by IE
+				options.path    ? '; path=' + options.path : '',
+				options.domain  ? '; domain=' + options.domain : '',
+				options.secure  ? '; secure' : ''
+			].join(''));
+		}
+
+		// Read
+
+		var result = key ? undefined : {};
+
+		// To prevent the for loop in the first place assign an empty array
+		// in case there are no cookies at all. Also prevents odd result when
+		// calling $.cookie().
+		var cookies = document.cookie ? document.cookie.split('; ') : [];
+
+		for (var i = 0, l = cookies.length; i < l; i++) {
+			var parts = cookies[i].split('=');
+			var name = decode(parts.shift());
+			var cookie = parts.join('=');
+
+			if (key && key === name) {
+				// If second argument (value) is a function it's a converter...
+				result = read(cookie, value);
+				break;
+			}
+
+			// Prevent storing a cookie that we couldn't decode.
+			if (!key && (cookie = read(cookie)) !== undefined) {
+				result[name] = cookie;
+			}
+		}
+
+		return result;
+	};
+
+	config.defaults = {};
+
+	$.removeCookie = function (key, options) {
+		if ($.cookie(key) === undefined) {
+			return false;
+		}
+
+		// Must not alter options, thus extending a fresh object...
+		$.cookie(key, '', $.extend({}, options, { expires: -1 }));
+		return !$.cookie(key);
+	};
+
+}));
Index: inc/js/jquery/3.3.1/jquery.cookie.js
===================================================================
--- inc/js/jquery/3.3.1/jquery.cookie.js	(revision 3829)
+++ inc/js/jquery/3.3.1/jquery.cookie.js	(revision 3829)
@@ -0,0 +1,117 @@
+/*!
+ * jQuery Cookie Plugin v1.4.1
+ * https://github.com/carhartl/jquery-cookie
+ *
+ * Copyright 2006, 2014 Klaus Hartl
+ * Released under the MIT license
+ */
+(function (factory) {
+	if (typeof define === 'function' && define.amd) {
+		// AMD
+		define(['jquery'], factory);
+	} else if (typeof exports === 'object') {
+		// CommonJS
+		factory(require('jquery'));
+	} else {
+		// Browser globals
+		factory(jQuery);
+	}
+}(function ($) {
+
+	var pluses = /\+/g;
+
+	function encode(s) {
+		return config.raw ? s : encodeURIComponent(s);
+	}
+
+	function decode(s) {
+		return config.raw ? s : decodeURIComponent(s);
+	}
+
+	function stringifyCookieValue(value) {
+		return encode(config.json ? JSON.stringify(value) : String(value));
+	}
+
+	function parseCookieValue(s) {
+		if (s.indexOf('"') === 0) {
+			// This is a quoted cookie as according to RFC2068, unescape...
+			s = s.slice(1, -1).replace(/\\"/g, '"').replace(/\\\\/g, '\\');
+		}
+
+		try {
+			// Replace server-side written pluses with spaces.
+			// If we can't decode the cookie, ignore it, it's unusable.
+			// If we can't parse the cookie, ignore it, it's unusable.
+			s = decodeURIComponent(s.replace(pluses, ' '));
+			return config.json ? JSON.parse(s) : s;
+		} catch(e) {}
+	}
+
+	function read(s, converter) {
+		var value = config.raw ? s : parseCookieValue(s);
+		return $.isFunction(converter) ? converter(value) : value;
+	}
+
+	var config = $.cookie = function (key, value, options) {
+
+		// Write
+
+		if (arguments.length > 1 && !$.isFunction(value)) {
+			options = $.extend({}, config.defaults, options);
+
+			if (typeof options.expires === 'number') {
+				var days = options.expires, t = options.expires = new Date();
+				t.setTime(+t + days * 864e+5);
+			}
+
+			return (document.cookie = [
+				encode(key), '=', stringifyCookieValue(value),
+				options.expires ? '; expires=' + options.expires.toUTCString() : '', // use expires attribute, max-age is not supported by IE
+				options.path    ? '; path=' + options.path : '',
+				options.domain  ? '; domain=' + options.domain : '',
+				options.secure  ? '; secure' : ''
+			].join(''));
+		}
+
+		// Read
+
+		var result = key ? undefined : {};
+
+		// To prevent the for loop in the first place assign an empty array
+		// in case there are no cookies at all. Also prevents odd result when
+		// calling $.cookie().
+		var cookies = document.cookie ? document.cookie.split('; ') : [];
+
+		for (var i = 0, l = cookies.length; i < l; i++) {
+			var parts = cookies[i].split('=');
+			var name = decode(parts.shift());
+			var cookie = parts.join('=');
+
+			if (key && key === name) {
+				// If second argument (value) is a function it's a converter...
+				result = read(cookie, value);
+				break;
+			}
+
+			// Prevent storing a cookie that we couldn't decode.
+			if (!key && (cookie = read(cookie)) !== undefined) {
+				result[name] = cookie;
+			}
+		}
+
+		return result;
+	};
+
+	config.defaults = {};
+
+	$.removeCookie = function (key, options) {
+		if ($.cookie(key) === undefined) {
+			return false;
+		}
+
+		// Must not alter options, thus extending a fresh object...
+		$.cookie(key, '', $.extend({}, options, { expires: -1 }));
+		return !$.cookie(key);
+	};
+
+}));
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 3814)
+++ inc/prepend.php	(revision 3816)
@@ -144,5 +144,5 @@
 # Constants
 define('DC_ROOT', path::real(dirname(__FILE__) . '/..'));
-define('DC_VERSION', '2.14.1');
+define('DC_VERSION', '2.15-dev');
 define('DC_DIGESTS', dirname(__FILE__) . '/digests');
 define('DC_L10N_ROOT', dirname(__FILE__) . '/../locales');
Index: plugins/aboutConfig/index.php
===================================================================
--- plugins/aboutConfig/index.php	(revision 3731)
+++ plugins/aboutConfig/index.php	(revision 3813)
@@ -123,5 +123,5 @@
 '  <th>' . __('Value') . '</th>' . "\n" .
 '  <th>' . __('Type') . '</th>' . "\n" .
-'  <th class="maximalx">' . __('Description') . '</th>' . "\n" .
+'  <th>' . __('Description') . '</th>' . "\n" .
     '</tr>' . "\n" .
     '</thead>' . "\n" .
Index: plugins/blogroll/class.dc.blogroll.php
===================================================================
--- plugins/blogroll/class.dc.blogroll.php	(revision 3731)
+++ plugins/blogroll/class.dc.blogroll.php	(revision 3817)
@@ -46,4 +46,28 @@
     }
 
+    public function getLangs($params = array())
+    {
+        // Use post_lang as an alias of link_lang to be able to use the dcAdminCombos::getLangsCombo() function
+        $strReq = 'SELECT COUNT(link_id) as nb_link, link_lang as post_lang ' .
+        'FROM ' . $this->table . ' ' .
+        "WHERE blog_id = '" . $this->con->escape($this->blog->id) . "' " .
+            "AND link_lang <> '' " .
+            "AND link_lang IS NOT NULL ";
+
+        if (isset($params['lang'])) {
+            $strReq .= "AND link_lang = '" . $this->con->escape($params['lang']) . "' ";
+        }
+
+        $strReq .= 'GROUP BY link_lang ';
+
+        $order = 'desc';
+        if (!empty($params['order']) && preg_match('/^(desc|asc)$/i', $params['order'])) {
+            $order = $params['order'];
+        }
+        $strReq .= 'ORDER BY link_lang ' . $order . ' ';
+
+        return $this->con->select($strReq);
+    }
+
     public function getLink($id)
     {
Index: plugins/blogroll/edit.php
===================================================================
--- plugins/blogroll/edit.php	(revision 3731)
+++ plugins/blogroll/edit.php	(revision 3817)
@@ -84,4 +84,8 @@
 }
 
+# Languages combo
+$links      = $blogroll->getLangs(array('order' => 'asc'));
+$lang_combo = dcAdminCombos::getLangsCombo($links, true);
+
 ?>
 <html>
@@ -147,5 +151,7 @@
 
     '<p><label for="link_lang">' . __('Language:') . '</label> ' .
-    form::field('link_lang', 5, 5, html::escapeHTML($link_lang)) . '</p>' .
+    form::combo('link_lang', $lang_combo, $link_lang) .
+    '</p>' .
+
     '</div>' .
 
@@ -153,4 +159,6 @@
     '<div class="col70 last-col">' .
     '<h3>' . __('XFN information') . '</h3>' .
+    '<p class="clear form-note">' . __('More information on <a href="https://en.wikipedia.org/wiki/XHTML_Friends_Network">Wikipedia</a> website') . '</p>' .
+
     '<div class="table-outer">' .
     '<table class="noborder">' .
Index: plugins/userPref/index.php
===================================================================
--- plugins/userPref/index.php	(revision 3731)
+++ plugins/userPref/index.php	(revision 3813)
@@ -122,5 +122,5 @@
 '  <th>' . __('Value') . '</th>' . "\n" .
 '  <th>' . __('Type') . '</th>' . "\n" .
-'  <th class="maximalx">' . __('Description') . '</th>' . "\n" .
+'  <th>' . __('Description') . '</th>' . "\n" .
     '</tr>' . "\n" .
     '</thead>' . "\n" .
Index: plugins/widgets/class.widgets.php
===================================================================
--- plugins/widgets/class.widgets.php	(revision 3731)
+++ plugins/widgets/class.widgets.php	(revision 3827)
@@ -274,4 +274,9 @@
                 return false;
             }
+            // If any, the 5th argument should be an array (key → value) of opts
+            $opts = @func_get_arg(5);
+        } else {
+            // If any, the 4th argument should be an array (key → value) of opts
+            $opts = @func_get_arg(4);
         }
 
@@ -285,4 +290,7 @@
             $this->settings[$name]['options'] = $options;
         }
+        if (isset($opt)) {
+            $this->settings[$name]['opts'] = $opts;
+        }
     }
 
@@ -308,9 +316,10 @@
         $wfid  = "wf-" . $i;
         $iname = $pr ? $pr . '[' . $id . ']' : $id;
+        $class = (isset($s['opts']) && isset($s['opts']['class']) ? ' ' . $s['opts']['class'] : '');
         switch ($s['type']) {
             case 'text':
                 $res .=
                 '<p><label for="' . $wfid . '">' . $s['title'] . '</label> ' .
-                form::field(array($iname, $wfid), 20, 255, html::escapeHTML($s['value']), 'maximal') .
+                form::field(array($iname, $wfid), 20, 255, html::escapeHTML($s['value']), 'maximal' . $class) .
                     '</p>';
                 break;
@@ -318,5 +327,5 @@
                 $res .=
                 '<p><label for="' . $wfid . '">' . $s['title'] . '</label> ' .
-                form::textarea(array($iname, $wfid), 30, 8, html::escapeHTML($s['value']), 'maximal') .
+                form::textarea(array($iname, $wfid), 30, 8, html::escapeHTML($s['value']), 'maximal' . $class) .
                     '</p>';
                 break;
@@ -325,5 +334,5 @@
                 '<p>' . form::hidden(array($iname), '0') .
                 '<label class="classic" for="' . $wfid . '">' .
-                form::checkbox(array($iname, $wfid), '1', $s['value']) . ' ' . $s['title'] .
+                form::checkbox(array($iname, $wfid), '1', $s['value'], $class) . ' ' . $s['title'] .
                     '</label></p>';
                 break;
@@ -335,5 +344,5 @@
                         $res .=
                         '<label class="classic" for="' . $wfid . '-' . $k . '">' .
-                        form::radio(array($iname, $wfid . '-' . $k), $v[1], $s['value'] == $v[1]) . ' ' . $v[0] .
+                        form::radio(array($iname, $wfid . '-' . $k), $v[1], $s['value'] == $v[1], $class) . ' ' . $v[0] .
                             '</label>';
                     }
@@ -344,5 +353,5 @@
                 $res .=
                 '<p><label for="' . $wfid . '">' . $s['title'] . '</label> ' .
-                form::combo(array($iname, $wfid), $s['options'], $s['value']) .
+                form::combo(array($iname, $wfid), $s['options'], $s['value'], $class) .
                     '</p>';
                 break;
Index: plugins/widgets/index.php
===================================================================
--- plugins/widgets/index.php	(revision 3731)
+++ plugins/widgets/index.php	(revision 3826)
@@ -223,5 +223,9 @@
 }
 if ($rte_flag) {
-    echo $core->callBehavior('adminPostEditor', $widget_editor['xhtml'], 'widget', array('#sidebarsWidgets textarea'), 'xhtml');
+    echo dcPage::jsVars(array('dotclear.widget_noeditor' => 0));
+    echo $core->callBehavior('adminPostEditor', $widget_editor['xhtml'], 'widget',
+        array('#sidebarsWidgets textarea:not(.noeditor)'), 'xhtml');
+} else {
+    echo dcPage::jsVars(array('dotclear.widget_noeditor' => 1));
 }
 echo (dcPage::jsConfirmClose('sidebarsWidgets'));
Index: plugins/widgets/js/dragdrop.js
===================================================================
--- plugins/widgets/js/dragdrop.js	(revision 3709)
+++ plugins/widgets/js/dragdrop.js	(revision 3826)
@@ -71,4 +71,14 @@
         'width': $('#widgets-ref > li').css('width')
       });
+    },
+    stop: function(event, ui) {
+      if (!dotclear.widget_noeditor) {
+        ui.helper.find('textarea:not(.noeditor)').each(function() {
+          if ($.isFunction(jsToolBar)) {
+            var tbWidgetText = new jsToolBar(this);
+            tbWidgetText.draw('xhtml');
+          }
+        })
+      }
     }
   });
Index: plugins/widgets/js/widgets.js
===================================================================
--- plugins/widgets/js/widgets.js	(revision 3768)
+++ plugins/widgets/js/widgets.js	(revision 3825)
@@ -123,5 +123,5 @@
   // HTML text editor
   if ($.isFunction(jsToolBar)) {
-    $('#sidebarsWidgets textarea').each(function() {
+    $('#sidebarsWidgets textarea:not(.noeditor)').each(function() {
       var tbWidgetText = new jsToolBar(this);
       tbWidgetText.draw('xhtml');
